Option Explicit On 
Option Strict On

Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D

Public Class frmMain
    Inherits System.Windows.Forms.Form

    Private Const COLOR_DEPTH_16_BIT As Format = Direct3D.Format.R5G6B5
    Private Const COLOR_DEPTH_24_BIT As Format = Direct3D.Format.A8R8G8B8
    Private Const COLOR_DEPTH_32_BIT As Format = Direct3D.Format.X8R8G8B8

    Private Direct3D_Device As Direct3D.Device = Nothing

    Private Fullscreen_Enabled As Boolean
    Private Running As Boolean = True
#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(304, 213)
        Me.Name = "frmMain"
        Me.Text = "Form1"

    End Sub

#End Region

    Private Sub DirectX9_Initialize()

        Dim Adapter As Direct3D.AdapterInformation
        Dim Display_Mode As Direct3D.DisplayMode
        Dim Direct3D_Window As PresentParameters = New PresentParameters

        If Fullscreen_Enabled = True Then

            Display_Mode.Width = 800
            Display_Mode.Height = 600
            Display_Mode.Format = COLOR_DEPTH_16_BIT

            'Check to see if fullscreen mode is supported before you use it.
            If Direct3D.Manager.CheckDeviceType(0, Direct3D.DeviceType.Hardware, Display_Mode.Format, Display_Mode.Format, False) Then
                ' Perfect, this is valid
                Direct3D_Window.Windowed = False
                Direct3D_Window.BackBufferCount = 1
                Direct3D_Window.BackBufferWidth = Display_Mode.Width
                Direct3D_Window.BackBufferHeight = Display_Mode.Height

            Else

                MessageBox.Show("Your video card doesn't support this screen resolution.", "", MessageBoxButtons.OK, MessageBoxIcon.Error)

            End If

        Else

            Direct3D_Window.Windowed = True


        End If

        Direct3D_Window.SwapEffect = SwapEffect.Copy
        Direct3D_Window.BackBufferFormat = Display_Mode.Format

        'Create our device
        Direct3D_Device = New Direct3D.Device(0, Direct3D.DeviceType.Hardware, Me.Handle, CreateFlags.SoftwareVertexProcessing, Direct3D_Window)

    End Sub

    Private Sub Render()

        Do While Running = True

            Application.DoEvents()

            Direct3D_Device.Clear(ClearFlags.Target, System.Drawing.Color.Black, 1.0F, 0)

            Direct3D_Device.BeginScene()

            Direct3D_Device.EndScene()

            Direct3D_Device.Present()

        Loop

    End Sub

    Private Sub Form1_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Activated

        Me.Text = "DirectX Tutorial"

        DirectX9_Initialize()

        Render()

    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown

        If e.KeyCode = Keys.Escape Then

            Running = False
            Direct3D_Device = Nothing
            Me.Close()
            End

        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If MessageBox.Show("Click Yes to go to full screen (Recommended)", "", MessageBoxButtons.YesNo, MessageBoxIcon.Information) = DialogResult.Yes Then

            Fullscreen_Enabled = True

        End If

    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing

        Running = False
        Direct3D_Device = Nothing
        'Me.Close() would give an error.
        End

    End Sub
End Class
